#!/bin/sh
id geronimo && chown -R geronimo /var/log/geronimo
id geronimo && chown -R geronimo /srv/www/geronimo/base

  PNAME=geronimo 
  SUBPNAME= 
    TEMPLATE_DIR=var/adm/fillup-templates 
    SYSC_TEMPLATE=$TEMPLATE_DIR/sysconfig.$PNAME$SUBPNAME 
    RC_TEMPLATE=$TEMPLATE_DIR/rc.config.$PNAME 
    SD_NAME="" 
     
    if [ -x bin/fillup ] ; then 
	
	if [ -f $SYSC_TEMPLATE ] ; then 
	    echo "Updating etc/sysconfig/$SD_NAME$PNAME..." 
	    if [ ! -d etc/sysconfig/$SD_NAME ] ; then 
		mkdir -p etc/sysconfig/$SD_NAME 
	    fi 
	    if [ -f etc/rc.config.d/$PNAME.rc.config ] ; then 
		if [ -f etc/sysconfig/$SD_NAME$PNAME ] ; then 
		    bin/fillup -q etc/sysconfig/$SD_NAME$PNAME etc/rc.config.d/$PNAME.rc.config 
		    rm -f etc/rc.config.d/$PNAME.rc.config 
		else 
		    mv etc/rc.config.d/$PNAME.rc.config etc/sysconfig/$SD_NAME$PNAME 
		fi 
	    fi 
	    if [ ! -f etc/rc.config ] ; then 
		test -f etc/sysconfig/$SD_NAME$PNAME || touch etc/sysconfig/$SD_NAME$PNAME 
		bin/fillup -q etc/sysconfig/$SD_NAME$PNAME $SYSC_TEMPLATE 
	    else 
	        if [ ! -f etc/sysconfig/$SD_NAME$PNAME ] ; then 
		    bin/fillup -q -r -i etc/rc.config $SYSC_TEMPLATE etc/sysconfig/$SD_NAME$PNAME 
	        else 
		    bin/fillup -q -r -i etc/rc.config $SYSC_TEMPLATE etc/sysconfig/$SD_NAME$PNAME.tmp 
		    bin/fillup -q etc/sysconfig/$SD_NAME$PNAME etc/sysconfig/$SD_NAME$PNAME.tmp 
		    rm -f etc/sysconfig/$SD_NAME$PNAME.tmp 
	        fi 
	        if [ -f etc/rc.config.new ] ; then 
		    mv etc/rc.config.new etc/rc.config 
	        fi 
	    fi
	fi 
	
	# maybe the fillup template for rc.config is old, make sure we do not readd stuff here 
	if [ -f $SYSC_TEMPLATE -a -f $RC_TEMPLATE ] ; then 
	  bin/fillup -q -r -i $RC_TEMPLATE $SYSC_TEMPLATE /dev/null 
	  mv $RC_TEMPLATE.new $RC_TEMPLATE 
	fi 
	# do the normal fillup for the rc.config variables 
	if [ -f $RC_TEMPLATE ] ; then 
	  bin/fillup -q -d = etc/rc.config $RC_TEMPLATE 
	fi 
    else 
	echo "ERROR: fillup not found. This should not happen. Please compare" 
	echo "etc/sysconfig/$SD_NAME$PNAME and $SYSC_TEMPLATE and" 
	echo "update by hand." 
    fi