<%--
  -   File: index.jsp
  -   
  -   Date         Version   Author               Changes
  -   Oct.03,2005  1.1       Vladimir Shraibman   Created
  -
  -   Copyright (c) 2005, IBM Corporation
  -   All rights reserved.
--%>

<%@ page language="java"
    contentType="text/html; charset=utf-8"
    pageEncoding="utf-8"
    import="com.ibm.j2g.webservices.client.*"
%>

<%!
    /* Name of the reference to the Search Phones service described in the web.xml file */
    private final static String SERVICE_REF_NAME = "java:comp/env/service/SearchPhones";

    /* Used for making hints to users */
    private final static com.ibm.j2g.webservices.server.PersonPhone[] AVAILABLE_PHONES =
        com.ibm.j2g.webservices.server.SearchPhonesServer.AVAILABLE_PHONES;

    /* Returns the endpoint for calling methods of the web service */
    public SearchPhonesPortType getService() throws Exception {
        javax.naming.InitialContext ctx = new javax.naming.InitialContext();
        SearchPhonesService service = (SearchPhonesService)ctx.lookup(SERVICE_REF_NAME);
        return service.getSearchPhonesService();
    }
%>

<%  String name = request.getParameter("name"); %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
           "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">     
<html>

<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Web Services Application</title>
</head>

<body>
    <h3>Search criterion</h3>
    <form action="#">
        <table>
        <tr>
            <td>Person name:</td>
            <td><input type="text" name="name" value="<%=(name != null ? name : "")%>"/></td>
        </tr>
        <tr>
            <td colspan="2"><input type="submit" value="Search"/></td>
        </tr>
        <tr>
            <td colspan="2">
                <br/>
                Hint: the following names are hardcoded:<br/>

                <% for (int i = 0; i < AVAILABLE_PHONES.length; i++) { %>
                    <%=AVAILABLE_PHONES[i].getPersonName()%><%=(i < AVAILABLE_PHONES.length - 1 ? ", " : " ")%>
                <% } %>
  
            </td>
        </tr>
        </table>
    </form>

<%  if (name != null && !name.equals("")) {
        PersonPhone[] foundPhones = getService().search(name); %>

        <br/>
        <h3>Search results</h3>
        <table >

            <% if (foundPhones == null || foundPhones.length == 0) { %>
                <tr><td>No persons which name starts with the specified criterion were found.</td></tr>

            <% } else { %>
                <tr><td colspan="2">The following persons and phones were found:</td></tr>

                <% for (int i = 0; i < foundPhones.length; i++) { %>
                <tr>
                    <td><%=foundPhones[i].getPersonName()%></td>
                    <td><%=foundPhones[i].getPhoneNumber()%></td>
                </tr>
                <% } %>

            <% } %>

        </table>

<%  } %>

</body>

</html>
